#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "defs.h"

void check_watches(int min) {
    
    int i,j;

    for (i = 0; i < 16 && kanaler[i].used == 1; i++) {
        for (j = 0; j < MAXCHAN && kanaler[i].program[j][0] != ' '; j++) { /* empty  */
            if (kanaler[i].watch[j] == 1 && conf.alarm1 != 0 && (kanaler[i].starttid[j] - min) > 0) { 
                if (kanaler[i].watch[j] == 1 && conf.alarm1 != 0 && kanaler[i].starttid[j] - min == conf.alarm1) {
                    do_alarms(1,i,j); /* 1 == conf.alarm1, i == channel, j == program */
                }
            }
            else if (kanaler[i].watch[j] == 1 && conf.alarm1 != 0 && kanaler[i].starttid[j] + 1440 - min  == conf.alarm1) {
                do_alarms(1,i,j);
            }
            if (kanaler[i].watch[j] == 1 && conf.alarm1 != 0 && (kanaler[i].starttid[j] - min) > 0) { 
                if (kanaler[i].watch[j] == 1 && conf.alarm1 != 0 && kanaler[i].starttid[j] - min == conf.alarm1) {
                    do_alarms(2,i,j); /* 1 == conf.alarm1, i == channel, j == program */
                }
            }
            else if (kanaler[i].watch[j] == 1 && conf.alarm1 != 0 && kanaler[i].starttid[j] + 1440 - min  == conf.alarm1) {
                do_alarms(2,i,j);
            }
        }
    }
}

void do_alarms(int alarmnum, int i, int j) {

    char ex_alarm1[256]; /* FIXME: maaaaaaaaaaagic numbers! */
    char ex_alarm2[256];

    if (alarmnum == 1) {
        if (conf.extalarm1[0] == '\0') {
            beep();
        }
        else {
            /* FIXME: fork() before */
            system(parse_extalarm(conf.extalarm1,i,j,ex_alarm1)); 
        }
    }
    else if (alarmnum == 2) {
        if (conf.extalarm2[0] == '\0') {
            beep();
        }
        else {
            system(parse_extalarm(conf.extalarm2,i,j,ex_alarm2));
        }
    }
}

char *parse_extalarm(const char *input, int i, int j, char *output) {  

    char starttime[6], stoptime[6];
    char tmpstr[256];
    char *p;
    char *q;


    memcpy(output,input,256);
    memcpy(tmpstr,input,256);
    if ((p = strstr(output,"%c")) != NULL) {                            /* channel */
        memcpy(p,kanaler[i].name,strlen(kanaler[i].name));
        p +=strlen(kanaler[i].name);
        q = strstr(tmpstr,"%c");
        q += 2;
        memcpy(p,q,strlen(q));
    }
    memcpy(tmpstr,output,256);
    if ((p = strstr(output,"%t")) != NULL) {                           /* start time */
        sprintf(starttime,"%.2d:%.2d",(kanaler[i].starttid[j] - kanaler[i].starttid[j]%60)/60, kanaler[i].starttid[j]%60);
        memcpy(p,starttime,5);
        p +=5;
        q = strstr(tmpstr,"%t");
        q += 2;
        memcpy(p,q,strlen(q));
    }
    memcpy(tmpstr,output,256);
    if ((p = strstr(output,"%s")) != NULL) {                           /* stop time */
        sprintf(stoptime,"%.2d:%.2d",(kanaler[i].starttid[j+1] - kanaler[i].starttid[j+1]%60)/60, kanaler[i].starttid[j+1]%60);
        memcpy(p,stoptime,5);
        p +=5;
        q = strstr(tmpstr,"%s");
        q += 2;
        memcpy(p,q,strlen(q));
    }
    memcpy(tmpstr,output,256);
    if ((p = strstr(output,"%p")) != NULL) {                          /* program */
        memcpy(p,kanaler[i].program[j],strlen(kanaler[i].program[j]));
        p +=strlen(kanaler[i].program[j]);
        q = strstr(tmpstr,"%p");
        q += 2;
        memcpy(p,q,strlen(q));
    }
    return output;       
}


